/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8995_SUPTRGO.sql

Descrio:
Criao:
10/07/2009 Marcelo Alexsandro
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'EXCLUI_NF_ENT_OL'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER EXCLUI_NF_ENT_OL
  GO

CREATE TRIGGER EXCLUI_NF_ENT_OL
ON NOTAFISCAL
FOR DELETE

AS
DECLARE @V_REGISTRO VARCHAR(1);
DECLARE @V_OLD_DSNOTAFISORIGOL VARCHAR(30);
DECLARE @V_NF_CDFILIAL         VARCHAR(4);
DECLARE @V_NF_NRLANCTONF       VARCHAR(10);
DECLARE @V_NF_CDFILDEST        VARCHAR(4);
DECLARE @V_NF_CDFILLANC        VARCHAR(4);
DECLARE @V_NF_NRPEDEXOL        VARCHAR(10);
DECLARE @V_NF_CDMARCA          VARCHAR(5);
DECLARE @V_NF_CDPRODUTO        VARCHAR(10)
DECLARE @V_NF_DTPROGENPEOL     DATETIME;

DECLARE @V_IDBAIXAAF           VARCHAR(1);
DECLARE @V_TOTALITEM           DOUBLE PRECISION;
DECLARE @V_BAIXATOTAL          DOUBLE PRECISION;
DECLARE @V_BAIXAMANUAL         DOUBLE PRECISION;
DECLARE @V_EMABERTO            DOUBLE PRECISION;
DECLARE @V_BAIXAPARCIAL        DOUBLE PRECISION;
DECLARE @V_REGISTRO_ANTERIOR   VARCHAR(18);
DECLARE @V_LISTA               VARCHAR(20);

DECLARE @V_LISTA_CDFILDEST     VARCHAR(4);
DECLARE @V_LISTA_CDFILLANC     VARCHAR(4);
DECLARE @V_LISTA_NRPEDEXOL     VARCHAR(10);

BEGIN
   DECLARE C_DELETE_NF CURSOR FOR
      SELECT DSNOTAFISORIGOL
      FROM DELETED
      WHERE 0 = (SELECT COUNT(*)
                 FROM INSERTED);
   OPEN C_DELETE_NF;
   FETCH NEXT FROM C_DELETE_NF INTO @V_OLD_DSNOTAFISORIGOL;
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      IF @V_OLD_DSNOTAFISORIGOL IS NOT NULL BEGIN
         EXEC NOVO_CODIGO_SC 'LISTA', @P_SEQUENCIAL = @V_LISTA OUTPUT, @P_QTDE = 1;
         SET @V_LISTA = SUBSTRING(@V_LISTA,11,10);
         SET @V_REGISTRO_ANTERIOR = ' ';
         SET @V_REGISTRO = 'N';
         DECLARE C_NF CURSOR FOR
            SELECT
                SUBSTRING(@V_OLD_DSNOTAFISORIGOL, 1, 4) CDFILIAL,
                SUBSTRING(@V_OLD_DSNOTAFISORIGOL, 5, 10) NRLANCTONF,
                CDFILDEST,
                CDFILLANC,
                NRPEDEXOL,
                CDMARCA,
                CDPRODUTO,
                DTPROGENPEOL
             FROM NFRELACPEXOL
             WHERE CDFILIAL = SUBSTRING(@V_OLD_DSNOTAFISORIGOL, 1, 4)
               AND NRLANCTONF = SUBSTRING(@V_OLD_DSNOTAFISORIGOL, 5, 10)
             ORDER BY CDFILDEST, CDFILLANC, NRPEDEXOL;
         OPEN C_NF;
         FETCH NEXT FROM C_NF INTO @V_NF_CDFILIAL,
                                   @V_NF_NRLANCTONF,
                                   @V_NF_CDFILDEST,
                                   @V_NF_CDFILLANC,
                                   @V_NF_NRPEDEXOL,
                                   @V_NF_CDMARCA,
                                   @V_NF_CDPRODUTO,
                                   @V_NF_DTPROGENPEOL;
         WHILE (@@FETCH_STATUS = 0)
         BEGIN
            IF @V_REGISTRO = 'N' BEGIN
               UPDATE NFRELACPEXOL
               SET IDENTRADAPEDOL = 'N'
               WHERE CDFILIAL = @V_NF_CDFILIAL
                 AND NRLANCTONF = @V_NF_NRLANCTONF;
               SET @V_REGISTRO = 'S';
            END;
            IF @V_REGISTRO_ANTERIOR <> @V_NF_CDFILDEST+@V_NF_CDFILLANC+@V_NF_NRPEDEXOL BEGIN
               INSERT INTO LISTA (NRLISTA, CDLISTA)
               SELECT
                  @V_LISTA,
                  @V_NF_CDFILDEST+@V_NF_CDFILLANC+@V_NF_NRPEDEXOL
               WHERE NOT EXISTS (SELECT 1
                                 FROM LISTA L
                                 WHERE L.NRLISTA = @V_LISTA
                                   AND L.CDLISTA = @V_NF_CDFILDEST+@V_NF_CDFILLANC+@V_NF_NRPEDEXOL);

               SET @V_REGISTRO_ANTERIOR = @V_NF_CDFILDEST+@V_NF_CDFILLANC+@V_NF_NRPEDEXOL;
            END;

            UPDATE ITEMPEDEXOL
            SET IDBAIXENPEOL = NULL
            WHERE CDFILDEST    = @V_NF_CDFILDEST
              AND CDFILLANC    = @V_NF_CDFILLANC
              AND NRPEDEXOL    = @V_NF_NRPEDEXOL
              AND CDMARCA      = @V_NF_CDMARCA
              AND CDPRODUTO    = @V_NF_CDPRODUTO
              AND DTPROGENPEOL = @V_NF_DTPROGENPEOL;

            FETCH NEXT FROM C_NF INTO @V_NF_CDFILIAL,
                                      @V_NF_NRLANCTONF,
                                      @V_NF_CDFILDEST,
                                      @V_NF_CDFILLANC,
                                      @V_NF_NRPEDEXOL,
                                      @V_NF_CDMARCA,
                                      @V_NF_CDPRODUTO,
                                      @V_NF_DTPROGENPEOL;
         END;
         CLOSE C_NF;
         DEALLOCATE C_NF;

         DECLARE C_LISTA CURSOR FOR
             SELECT
                 SUBSTRING(CDLISTA, 1, 4) CDFILDEST,
                 SUBSTRING(CDLISTA, 5, 4) CDFILLANC,
                 SUBSTRING(CDLISTA, 9, 10) NRPEDEXOL
             FROM LISTA
             WHERE NRLISTA = @V_LISTA;
         OPEN C_LISTA;
         FETCH NEXT FROM C_LISTA INTO @V_LISTA_CDFILDEST,
                                      @V_LISTA_CDFILLANC,
                                      @V_LISTA_NRPEDEXOL;
         WHILE (@@FETCH_STATUS = 0)
         BEGIN
            SET @V_TOTALITEM    = 0;
            SET @V_BAIXATOTAL   = 0;
            SET @V_BAIXAMANUAL  = 0;
            SET @V_EMABERTO     = 0;
            SET @V_BAIXAPARCIAL = 0;

            SELECT @V_TOTALITEM = COUNT(*)  -- BUSCA O TOTAL DE ITENS DA AF
            FROM ITEMPEDEXOL
            WHERE
               @V_LISTA_CDFILDEST = ITEMPEDEXOL.CDFILDEST AND
               @V_LISTA_CDFILLANC = ITEMPEDEXOL.CDFILLANC AND
               @V_LISTA_NRPEDEXOL = ITEMPEDEXOL.NRPEDEXOL;

            SELECT @V_EMABERTO = COUNT(*)   -- BUSCA O TOTAL DE ITENS DA AF EM ABERTO
            FROM ITEMPEDEXOL
            WHERE
               @V_LISTA_CDFILDEST = ITEMPEDEXOL.CDFILDEST AND
               @V_LISTA_CDFILLANC = ITEMPEDEXOL.CDFILLANC AND
               @V_LISTA_NRPEDEXOL = ITEMPEDEXOL.NRPEDEXOL AND
               ITEMPEDEXOL.IDBAIXENPEOL IS NULL;

            SELECT @V_BAIXAPARCIAL = COUNT(*) -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA PARCIAL
            FROM ITEMPEDEXOL
            WHERE
               @V_LISTA_CDFILDEST = ITEMPEDEXOL.CDFILDEST AND
               @V_LISTA_CDFILLANC = ITEMPEDEXOL.CDFILLANC AND
               @V_LISTA_NRPEDEXOL = ITEMPEDEXOL.NRPEDEXOL AND
               ITEMPEDEXOL.IDBAIXENPEOL = '1';

            SELECT @V_BAIXATOTAL = COUNT(*)   -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA TOTAL
            FROM ITEMPEDEXOL
            WHERE
               @V_LISTA_CDFILDEST = ITEMPEDEXOL.CDFILDEST AND
               @V_LISTA_CDFILLANC = ITEMPEDEXOL.CDFILLANC AND
               @V_LISTA_NRPEDEXOL = ITEMPEDEXOL.NRPEDEXOL AND
               ITEMPEDEXOL.IDBAIXENPEOL = '2';

            SELECT @V_BAIXAMANUAL = COUNT(*)   -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA MANUAL
            FROM ITEMPEDEXOL
            WHERE
               @V_LISTA_CDFILDEST = ITEMPEDEXOL.CDFILDEST AND
               @V_LISTA_CDFILLANC = ITEMPEDEXOL.CDFILLANC AND
               @V_LISTA_NRPEDEXOL = ITEMPEDEXOL.NRPEDEXOL AND
               ITEMPEDEXOL.IDBAIXENPEOL = '3';

            IF @V_TOTALITEM = @V_EMABERTO BEGIN
               SET @V_IDBAIXAAF = NULL;  -- AF EM ABERTO
            END;
            IF @V_TOTALITEM = @V_BAIXATOTAL BEGIN
               SET @V_IDBAIXAAF = '2';   -- AF COM BAIXA TOTAL
            END;
            IF @V_BAIXAPARCIAL > 0 BEGIN
               SET @V_IDBAIXAAF = '1';       -- AF COM BAIXA PARCIAL
            END;
            IF (@V_TOTALITEM = @V_BAIXATOTAL + @V_BAIXAMANUAL) AND
               (@V_BAIXAMANUAL > 0) BEGIN
               SET @V_IDBAIXAAF = '3';   -- AF COM BAIXA MANUAL
            END;
            IF (@V_TOTALITEM = @V_BAIXATOTAL + @V_BAIXAMANUAL + @V_EMABERTO) AND
               (@V_EMABERTO > 0) AND (@V_EMABERTO < @V_TOTALITEM) BEGIN
               SET @V_IDBAIXAAF = '1';   -- AF COM BAIXA PARCIAL
            END;

            UPDATE PEDIDOEXOL  -- ALTERA O ID DE BAIXA DA AF
            SET IDBAIXEXOL = @V_IDBAIXAAF
            WHERE
               @V_LISTA_CDFILDEST = PEDIDOEXOL.CDFILDEST AND
               @V_LISTA_CDFILLANC = PEDIDOEXOL.CDFILLANC AND
               @V_LISTA_NRPEDEXOL = PEDIDOEXOL.NRPEDEXOL;

            FETCH NEXT FROM C_LISTA INTO @V_LISTA_CDFILDEST,
                                         @V_LISTA_CDFILLANC,
                                         @V_LISTA_NRPEDEXOL;
         END;
         CLOSE C_LISTA;
         DEALLOCATE C_LISTA;
      END;
      FETCH NEXT FROM C_DELETE_NF INTO @V_OLD_DSNOTAFISORIGOL;
   END;
   CLOSE C_DELETE_NF;
   DEALLOCATE C_DELETE_NF;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'EXCLUI_NF_ENT_OL','5.05.066';
GO


