function Exp0800_comissaoVendedorPeriodo_Controller(templateManager, General, ScreenService, Exp0800_comissaoVendedorPeriodo_Service, ZhFilterPreferences, ZHPromise) {
    
    var mensagens = {
        errorBloqueado: 'O mapa já esta bloqueado.',
        mapaBloqueado: 'Mapa bloqueado com sucesso!',
        errorDesbloqueado: 'O mapa já esta desbloqueado.',
        mapaDesbloqueado: 'Mapa desbloqueado com sucesso.',
        errorApurar: 'Desbloqueie o mapa antes de apurar.',
        apuradoSucesso: 'Mapa apurado com sucesso!',
        apuradoError: 'Erro ao apurar o mapa!',
        alertaMapas: 'Existem notas/contas com alerta. Deseja continuar?',
        notaOutroPeriodo: 'Esta nota já foi apurada em outro periodo.',
        contaOutroPeriodo: 'Esta conta já foi apurada em outro periodo.',
        errorContaPagar: 'Ocorreu um erro ao gerar a conta!',
        contaPagarExistente: 'Esse mapa já possui contas a pagar.',
        bloquearMapa: 'O Mapa precisa ser bloqueado. Deseja bloquear agora?',
        desbloquarMapa: 'O Mapa precisa ser bloqueado. Deseja bloquear agora?',
        salvoSucesso: 'Salvo com sucesso!',
        errorSalvar:  'Ocorreu um erro a salvar',
        errorSaveComissao: 'Existe uma ou mais contas a pagar relacionadas a este item. Não foi possivel alterar o valor da comissão.',
        bloqOperacao: 'Este mapa possui contas a pagar. Não foi possivel ',
        apurarComissao: 'Existem mapas de periodos anteriores desbloqueados as notas/contas não apuradas serão incluidas neste mapa. Deseja continuar? '
    };  
    
    this.startFiltering = function(widgetPedidos){
        
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widgetPedidos.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widgetPedidos));
        ZHPromise.all(promises).then(function(rowSetFilter){
        }.bind(this)); 
    };
    
    this.adicionar = function(widget) {
        var row = {
            CDVENDEDOR: widget.getParent().currentRow.CDVENDEDOR,
            CDFILICOMIS: widget.getParent().currentRow.CDFILICOMIS,
            NRMAPACOMIS: widget.getParent().currentRow.NRMAPACOMIS
        };
        Exp0800_comissaoVendedorPeriodo_Service.verificaContaPagar(row).then(function(success){
            if(success.dataset.mapacompag[0]) {
                //ScreenService.showMessage(mensagens.bloqOperacao.concat('adicionar.'));
                ScreenService.showMessage("Este mapa possui contas a pagar. Não foi possivel adicionar.");
            }
            else {
                General.widgetNewRow(widget);
            }
        });
    };
    
    this.setDATAATUAL = function(widget){
        if(templateManager.container.getWidget('contas_a_pagar').dataSource.data.length > 0){
            templateManager.container.getWidget('contas_a_pagar').dataSource.data[0].DATAATUAL = moment().format('DD/MM/YYYY hh:mm:ss');
        }
    };
    
    this.apurarComissao = function(widget) {
            if(widget.currentRow.IDBLOQMAPACOMIS === 'N') {
            var row = { INICIAL: widget.currentRow.DTINIPERIODO,
                                        FINAL: widget.currentRow.DTFIMPERIODO,
                                        VENDEDOR: widget.currentRow.CDVENDEDOR,
                                        NRORG: widget.currentRow.NRORG,
                                        CDFILIAL: widget.currentRow.CDFILICOMIS,
                                        NRMAPACOMIS: widget.currentRow.NRMAPACOMIS
                            };  
            
           Exp0800_comissaoVendedorPeriodo_Service.verificaMapasAnteriores(row).then(function(success){
                if(success.dataset.mapacomperiodo[0]) {
                    //ScreenService.confirmMessage(ScreenService.i18n(mensagens.apurarComissao), 'question', function (success) {
                    ScreenService.confirmMessage("Existem mapas de periodos anteriores desbloqueados as notas/contas não apuradas serão incluidas neste mapa. Deseja continuar?", 'question', function(success){    
                        row.MAPAOUTROPERIODO = 'S';
                        ScreenService.confirmMessage(ScreenService.i18n('Deletar notas/contas fora do período?'), 'question', function (success) {
                            row.excluiForaPeriodo = 'S';
                            Exp0800_comissaoVendedorPeriodo_Service.apurarComissao(row).then(function(success){
                                //ScreenService.showMessage(mensagens.apuradoSucesso);
                                ScreenService.showMessage("Mapa apurado com sucesso!");
                                ScreenService.closePopup();
                                widget.reload();
                            }.bind(this),
                            function(error) {
                                //ScreenService.showMessage(mensagens.apuradoError);
                                ScreenService.showMessage("Erro ao apurar o mapa!");
                            });
                        }.bind(this), 
                        function(error) {
                           row.excluiForaPeriodo = 'N';
                            Exp0800_comissaoVendedorPeriodo_Service.apurarComissao(row).then(function(success){
                                //ScreenService.showMessage(mensagens.apuradoSucesso);
                                ScreenService.showMessage("Mapa apurado com sucesso!");
                                ScreenService.closePopup();
                                widget.reload();
                                templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
                                
                            },
                            function(error) {
                                //ScreenService.showMessage(mensagens.apuradoError);
                                ScreenService.showMessage("Erro ao apurar o mapa!");
                            });
                        }.bind(this));
                    }.bind(this),
                    function(error) {
                            ScreenService.closePopup();
                    });
                } else {
                    row.MAPAOUTROPERIODO = 'N';
                    ScreenService.confirmMessage(ScreenService.i18n('Deseja excluir o detalhamento do mapa?'), 'question', function (success) {
                        row.excluiForaPeriodo = 'S';
                        Exp0800_comissaoVendedorPeriodo_Service.apurarComissao(row).then(function(success){
                            //ScreenService.showMessage(mensagens.apuradoSucesso);
                            ScreenService.showMessage("Mapa apurado com sucesso!");
                            ScreenService.closePopup();
                            widget.reload();
                        }.bind(this),
                        function(error) {
                            //ScreenService.showMessage(mensagens.apuradoError);
                            ScreenService.showMessage("Erro ao apurar o mapa!");
                        });
                    }.bind(this), 
                    function(error) {
                           row.excluiForaPeriodo = 'N';
                            Exp0800_comissaoVendedorPeriodo_Service.apurarComissao(row).then(function(success){
                                //ScreenService.showMessage(mensagens.apuradoSucesso);
                                ScreenService.showMessage("Mapa apurado com sucesso!");
                                ScreenService.closePopup();
                                widget.reload();
                                templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
                                
                            }.bind(this),
                            function(error) {
                                //ScreenService.showMessage(mensagens.apuradoError);
                                ScreenService.showMessage("Erro ao apurar o mapa!");
                            });
                	}.bind(this));

                   
                }
    	   
           }.bind(this));
        }
        //else ScreenService.showMessage(mensagens.errorApurar);
        else ScreenService.showMessage("Desbloqueie o mapa antes de apurar.");
    };
    
    this.saveNota = function(widget) {
        
        if(!widget.currentRow.EDITCOMISSAO) {
            widget.currentRow.EDITCOMISSAO = false;
        }
        widget.currentRow.NRORG = widget.getParent().currentRow.NRORG;
        var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
		var row = Util.clone(widget.currentRow, ignoredKeys);

        Exp0800_comissaoVendedorPeriodo_Service.saveNota(row).then(function(success){
            if(success.dataset) {
                //ScreenService.showMessage(mensagens.notaOutroPeriodo);
                ScreenService.showMessage("Esta nota já foi apurada em outro periodo.");
            }
            ScreenService.goBack();
            //ScreenService.showMessage(mensagens.salvoSucesso).then(function(){
            ScreenService.showMessage("Salvo com sucesso!").then(function(){    
                widget.reload();
                templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
            }.bind(this));
        }.bind(this),
        function(error) {
            //ScreenService.showMessage(mensagens.errorSave);
            ScreenService.showMessage("Ocorreu um erro a salvar");
        });
        
       
    };
    
    this.saveConta = function(widget) {
        widget.currentRow.NRORG = widget.getParent().currentRow.NRORG;
        if(!widget.currentRow.EDITCOMISSAO) {
            widget.currentRow.EDITCOMISSAO = false;
        }
        var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
		var row = Util.clone(widget.currentRow, ignoredKeys);
        row.NEWROW = true;
        Exp0800_comissaoVendedorPeriodo_Service.saveConta(row).then(function(success){
             if(success.dataset) {
                //ScreenService.showMessage(mensagens.contaOutroPeriodo);
                ScreenService.showMessage("Esta conta já foi apurada em outro periodo.");
            }
            ScreenService.goBack();
            //ScreenService.showMessage(mensagens.salvoSucesso).then(function(){
              ScreenService.showMessage("Salvo com sucesso!").then(function(){
                widget.reload();
                templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
            }.bind(this));
        }.bind(this),
        function(error) {
            //ScreenService.showMessage(mensagens.errorSave);
            ScreenService.showMessage("Ocorreu um erro a salvar");
        });
    };
    
    this.situacaoMapa = function(widget, boolean) {
        // Quando boolean é true o mapa é bloqueado
        // Quando boolean é false o mapa é desbloqueado
        if(boolean) {
            //Verifica se o mapa já esta bloqueado 
            if(widget.currentRow.IDBLOQMAPACOMIS === 'S') {
                //ScreenService.showMessage(mensagens.errorBloqueado);
                ScreenService.showMessage("O mapa já esta bloqueado.");
                return 0;
            }
            else {
                
                var row = { 
                    VENDEDOR: widget.currentRow.CDVENDEDOR,
                    NRORG: widget.currentRow.NRORG,
                    CDFILIAL: widget.currentRow.CDFILICOMIS,
                    NRMAPACOMIS: widget.currentRow.NRMAPACOMIS
                };  
                ZHPromise.all(Exp0800_comissaoVendedorPeriodo_Service.verificaAlertaMapas(row)).then(function(success){
                    if(success.dataset.mapacomexp.ERRO === true)  {
                    	//ScreenService.confirmMessage(ScreenService.i18n(mensagens.alertaMapas), 'question', function (success) {
                    	ScreenService.confirmMessage("Existem notas/contas com alerta. Deseja continuar?", 'question', function (success) {
                    	    widget.currentRow.IDBLOQMAPACOMIS = 'S';
                	        General.saveCrud(widget).then(function(success){
                                widget.reload();
                                ScreenService.closePopup();
                                //ScreenService.showMessage(mensagens.mapaBloqueado);
                                ScreenService.showMessage("Mapa bloqueado com sucesso!");
                             });
                    	},
                    	function(error) {
                    	    ScreenService.closePopup();
                    	});
                    }
                    else {
                        widget.currentRow.IDBLOQMAPACOMIS = 'S';
                        General.saveCrud(widget).then(function(success){
                            widget.reload();
                            ScreenService.closePopup();
                            //ScreenService.showMessage(mensagens.mapaBloqueado);
                            ScreenService.showMessage("Mapa bloqueado com sucesso!");
                        });
                    }
                },
                function(error){
                    ScreenService.showMessage('Erro ao bloquear mapa');
                });
            }
            
        }
        else {
            //Verifica se o mapa já esta desbloqueado
            if(widget.currentRow.IDBLOQMAPACOMIS === 'N') {
                //ScreenService.showMessage(mensagens.errorDesbloqueado);
                ScreenService.showMessage("O mapa já esta desbloqueado.");
                return 0;
            } 
            else widget.currentRow.IDBLOQMAPACOMIS = 'N';
            General.saveCrud(widget).then(function(success){
                widget.reload();
                ScreenService.closePopup();
                if(boolean) {
                    //ScreenService.showMessage(mensagens.mapaBloqueado);
                    ScreenService.showMessage("Mapa bloqueado com sucesso!");
                }
                //else ScreenService.showMessage(mensagens.mapaDesbloqueado);
                else ScreenService.showMessage("Mapa desbloqueado com sucesso.");
            
             });
        }
      
        
        
    };
    
    this.gerarContaPagar = function(widget) {
         var row = { 
            VENDEDOR    : widget.getParent().currentRow.CDVENDEDOR,
            NRORG       : widget.getParent().currentRow.NRORG,
            CDFILIAL    : widget.getParent().currentRow.CDFILICOMIS,
            NRMAPACOMIS : widget.getParent().currentRow.NRMAPACOMIS,
            VRCONTAPAG  : widget.getParent().currentRow.VRCOMISTOTAL
        };  
        if(widget.getParent().currentRow.IDBLOQMAPACOMIS === 'N') {
            //ScreenService.confirmMessage(ScreenService.i18n(mensagens.bloquearMapa), 'question', function (success) {
            ScreenService.confirmMessage("O Mapa precisa ser bloqueado. Deseja bloquear agora?", 'question', function(success) {
                this.situacaoMapa(widget.getParent(), true);
                if(widget.dataSource.data[0]) {
                    //ScreenService.showMessage(mensagens.contaPagarExistente);
                    ScreenService.showMessage("Esse mapa já possui contas a pagar.");
                }
                else {
                    Exp0800_comissaoVendedorPeriodo_Service.gerarContaPagar(row).then(function(success) {
                        widget.reload();
                        
                    },
                    function(error) {
                        //ScreenService.showMessage(mensagens.errorContaPagar);
                        ScreenService.showMessage("Ocorreu um erro ao gerar a conta!");
                    }
                    );  
                }  
            }.bind(this));    
        }
        else {
            if(widget.dataSource.data[0]) {
                //ScreenService.showMessage(mensagens.contaPagarExistente);
                ScreenService.showMessage("Esse mapa já possui contas a pagar.");
            }
            else {
                Exp0800_comissaoVendedorPeriodo_Service.gerarContaPagar(row).then(function(success) {
                    widget.reload();
                },
                function(error) {
                    if(error.data.error !== "Fornecedor não possui tipo de conta cadastrada."){
                        //ScreenService.showMessage(mensagens.errorContaPagar);
                        ScreenService.showMessage("Ocorreu um erro ao gerar a conta!");
                        
                    }else{
                        ScreenService.showMessage("Fornecedor não possui tipo de conta cadastrada.");
                    }
                });  
            }
        }
    };
    
    this.saveComissaoProduto = function(widget) {
        widget.currentRow.EDITCOMISSAO = true;
        widget.currentRow.NRORG        = widget.getParent().currentRow.NRORG;
        widget.currentRow.NRMAPACOMIS  = widget.getParent().currentRow.NRMAPACOMIS;
        widget.currentRow.VENDEDOR     = widget.getParent().currentRow.CDVENDEDOR;
        widget.currentRow.CDVENDEDOR   = widget.getParent().currentRow.CDVENDEDOR;
        widget.currentRow.CDFILIAL     = widget.getParent().currentRow.CDFILICOMIS;
        widget.currentRow.__is_new     = false;
        Exp0800_comissaoVendedorPeriodo_Service.saveComissaoProduto(widget.currentRow).then(function(success) {
            ScreenService.goBack();
            widget.reload();
            templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
            //ScreenService.showMessage(mensagens.salvoSucesso);
            ScreenService.showMessage("Salvo com sucesso!");
        }.bind(this), function(error) {
            //ScreenService.showMessage(mensagens.errorSaveComissao);
            ScreenService.showMessage("Existe uma ou mais contas a pagar relacionadas a este item. Não foi possivel alterar o valor da comissão.");
        });
    };
    
    this.editComissao = function(widget) {
         var row = {
            CDVENDEDOR: widget.getParent().currentRow.CDVENDEDOR,
            CDFILICOMIS: widget.getParent().currentRow.CDFILICOMIS,
            NRMAPACOMIS: widget.getParent().currentRow.NRMAPACOMIS
        };
        Exp0800_comissaoVendedorPeriodo_Service.verificaContaPagar(row).then(function(success){
            if(success.dataset.mapacompag[0]) {
                //ScreenService.showMessage(mensagens.bloqOperacao.concat('editar.'));
                ScreenService.showMessage("Este mapa possui contas a pagar. Não foi possivel editar.");
            }
            else {
                if(templateManager.container.getWidget('comissao_do_vendedor_por_periodo').currentRow.IDBLOQMAPACOMIS === 'S') {
                    //ScreenService.confirmMessage(ScreenService.i18n(mensagens.desbloquarMapa), 'question', function (success) {
                    ScreenService.confirmMessage("O Mapa precisa ser bloqueado. Deseja bloquear agora?", 'question', function (success) {
                        General.widgetEdit(widget);
                    });
                }
                else {
                    General.widgetEdit(widget);
                }
            }
        }.bind(this));
    };
    
    this.excluirMapa = function(widget) {
        var row = {
            CDVENDEDOR: widget.currentRow.CDVENDEDOR,
            CDFILICOMIS: widget.currentRow.CDFILICOMIS,
            NRMAPACOMIS: widget.currentRow.NRMAPACOMIS,
            NRORG: widget.currentRow.NRORG
        };
        Exp0800_comissaoVendedorPeriodo_Service.verificaContaPagar(row).then(function(success){
            if(success.dataset.mapacompag[0]) {
                //ScreenService.showMessage(mensagens.bloqOperacao.concat('excluir.'));
                ScreenService.showMessage("Este mapa possui contas a pagar. Não foi possivel excluir.");
            }
            else {
                 var row = { 
                    CDVENDEDOR    : widget.currentRow.CDVENDEDOR,
                    NRORG       : widget.currentRow.NRORG,
                    CDFILIAL    : widget.currentRow.CDFILIAL,
                    NRMAPACOMIS : widget.currentRow.NRMAPACOMIS,
                    CDFILICOMIS: widget.currentRow.CDFILICOMIS,
                    dataSourceName: 'mapacomperiodo'
                }; 
                Exp0800_comissaoVendedorPeriodo_Service.excluirMapa(row).then(function(success){
                    ScreenService.showMessage('Deletado com sucesso!');
                    ScreenService.goBack();
                    widget.reload();
                }.bind(this),
                function(error){
                    ScreenService.showMessage('Ocorreu um erro ao deletar');
                });
            }
        }.bind(this));
    };
    
    this.excluir = function(widget) {
        var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
		var row = Util.clone(widget.currentRow, ignoredKeys);
        Exp0800_comissaoVendedorPeriodo_Service.verificaContaPagar(row).then(function(success){

            if(success.dataset.mapacompag[0]) {
                //ScreenService.showMessage(mensagens.bloqOperacao.concat('excluir.'));
                ScreenService.showMessage("Este mapa possui contas a pagar. Não foi possivel excluir.");
            }    
            else {
                General.deleteCrud(widget).then(function(success){
                    templateManager.container.getWidget('comissao_do_vendedor_por_periodo').reload();
                }.bind(this));
            }
        }.bind(this));
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('Exp0800_comissaoVendedorPeriodo_Controller', Exp0800_comissaoVendedorPeriodo_Controller);
});